Index: admin/js/jquery/jquery-ui.custom.js
===================================================================
--- admin/js/jquery/jquery-ui.custom.js	(revision 1048)
+++ admin/js/jquery/jquery-ui.custom.js	(revision 1648)
@@ -2633,191 +3751,3 @@
 });
 
-
-
-// DEPRECATED
-if ( $.uiBackCompat !== false ) {
-	// navigation options
-	(function( $, prototype ) {
-		$.extend( prototype.options, {
-			navigation: false,
-			navigationFilter: function() {
-				return this.href.toLowerCase() === location.href.toLowerCase();
-			}
-		});
-
-		var _create = prototype._create;
-		prototype._create = function() {
-			if ( this.options.navigation ) {
-				var that = this,
-					headers = this.element.find( this.options.header ),
-					content = headers.next(),
-					current = headers.add( content )
-						.find( "a" )
-						.filter( this.options.navigationFilter )
-						[ 0 ];
-				if ( current ) {
-					headers.add( content ).each( function( index ) {
-						if ( $.contains( this, current ) ) {
-							that.options.active = Math.floor( index / 2 );
-							return false;
-						}
-					});
-				}
-			}
-			_create.call( this );
-		};
-	}( jQuery, jQuery.ui.accordion.prototype ) );
-
-	// height options
-	(function( $, prototype ) {
-		$.extend( prototype.options, {
-			heightStyle: null, // remove default so we fall back to old values
-			autoHeight: true, // use heightStyle: "auto"
-			clearStyle: false, // use heightStyle: "content"
-			fillSpace: false // use heightStyle: "fill"
-		});
-
-		var _create = prototype._create,
-			_setOption = prototype._setOption;
-
-		$.extend( prototype, {
-			_create: function() {
-				this.options.heightStyle = this.options.heightStyle ||
-					this._mergeHeightStyle();
-
-				_create.call( this );
-			},
-
-			_setOption: function( key ) {
-				if ( key === "autoHeight" || key === "clearStyle" || key === "fillSpace" ) {
-					this.options.heightStyle = this._mergeHeightStyle();
-				}
-				_setOption.apply( this, arguments );
-			},
-
-			_mergeHeightStyle: function() {
-				var options = this.options;
-
-				if ( options.fillSpace ) {
-					return "fill";
-				}
-
-				if ( options.clearStyle ) {
-					return "content";
-				}
-
-				if ( options.autoHeight ) {
-					return "auto";
-				}
-			}
-		});
-	}( jQuery, jQuery.ui.accordion.prototype ) );
-
-	// icon options
-	(function( $, prototype ) {
-		$.extend( prototype.options.icons, {
-			activeHeader: null, // remove default so we fall back to old values
-			headerSelected: "ui-icon-triangle-1-s"
-		});
-
-		var _createIcons = prototype._createIcons;
-		prototype._createIcons = function() {
-			if ( this.options.icons ) {
-				this.options.icons.activeHeader = this.options.icons.activeHeader ||
-					this.options.icons.headerSelected;
-			}
-			_createIcons.call( this );
-		};
-	}( jQuery, jQuery.ui.accordion.prototype ) );
-
-	// expanded active option, activate method
-	(function( $, prototype ) {
-		prototype.activate = prototype._activate;
-
-		var _findActive = prototype._findActive;
-		prototype._findActive = function( index ) {
-			if ( index === -1 ) {
-				index = false;
-			}
-			if ( index && typeof index !== "number" ) {
-				index = this.headers.index( this.headers.filter( index ) );
-				if ( index === -1 ) {
-					index = false;
-				}
-			}
-			return _findActive.call( this, index );
-		};
-	}( jQuery, jQuery.ui.accordion.prototype ) );
-
-	// resize method
-	jQuery.ui.accordion.prototype.resize = jQuery.ui.accordion.prototype.refresh;
-
-	// change events
-	(function( $, prototype ) {
-		$.extend( prototype.options, {
-			change: null,
-			changestart: null
-		});
-
-		var _trigger = prototype._trigger;
-		prototype._trigger = function( type, event, data ) {
-			var ret = _trigger.apply( this, arguments );
-			if ( !ret ) {
-				return false;
-			}
-
-			if ( type === "beforeActivate" ) {
-				ret = _trigger.call( this, "changestart", event, {
-					oldHeader: data.oldHeader,
-					oldContent: data.oldPanel,
-					newHeader: data.newHeader,
-					newContent: data.newPanel
-				});
-			} else if ( type === "activate" ) {
-				ret = _trigger.call( this, "change", event, {
-					oldHeader: data.oldHeader,
-					oldContent: data.oldPanel,
-					newHeader: data.newHeader,
-					newContent: data.newPanel
-				});
-			}
-			return ret;
-		};
-	}( jQuery, jQuery.ui.accordion.prototype ) );
-
-	// animated option
-	// NOTE: this only provides support for "slide", "bounceslide", and easings
-	// not the full $.ui.accordion.animations API
-	(function( $, prototype ) {
-		$.extend( prototype.options, {
-			animate: null,
-			animated: "slide"
-		});
-
-		var _create = prototype._create;
-		prototype._create = function() {
-			var options = this.options;
-			if ( options.animate === null ) {
-				if ( !options.animated ) {
-					options.animate = false;
-				} else if ( options.animated === "slide" ) {
-					options.animate = 300;
-				} else if ( options.animated === "bounceslide" ) {
-					options.animate = {
-						duration: 200,
-						down: {
-							easing: "easeOutBounce",
-							duration: 1000
-						}
-					};
-				} else {
-					options.animate = options.animated;
-				}
-			}
-
-			_create.call( this );
-		};
-	}( jQuery, jQuery.ui.accordion.prototype ) );
-}
-
 })( jQuery );
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 1636)
+++ admin/media.php	(revision 1678)
@@ -422,5 +422,5 @@
 {
 	echo
-	'<p class="zip-dl"><a href="'.html::escapeURL($page_url).'&amp;zipdl=1">'.
+	'<p class="zip-dl"><a class="submit" href="'.html::escapeURL($page_url).'&amp;zipdl=1">'.
 	__('Download this directory as a zip file').'</a></p>';
 }
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 1599)
+++ inc/admin/lib.dc.page.php	(revision 1655)
@@ -792,16 +792,4 @@
 }
 
-public static function jsToolMan()
-{
-	return
-	'<script type="text/javascript" src="js/tool-man/core.js"></script>'.
-	'<script type="text/javascript" src="js/tool-man/events.js"></script>'.
-	'<script type="text/javascript" src="js/tool-man/css.js"></script>'.
-	'<script type="text/javascript" src="js/tool-man/coordinates.js"></script>'.
-	'<script type="text/javascript" src="js/tool-man/drag.js"></script>'.
-	'<script type="text/javascript" src="js/tool-man/dragsort.js"></script>'.
-	'<script type="text/javascript" src="js/dragsort-tablerows.js"></script>';
-}
-
 public static function jsMetaEditor()
 {
Index: inc/admin/lib.pager.php
===================================================================
--- inc/admin/lib.pager.php	(revision 1622)
+++ inc/admin/lib.pager.php	(revision 1670)
@@ -136,9 +136,9 @@
 		'<td class="maximal" scope="row"><a href="'.$this->core->getPostAdminURL($this->rs->post_type,$this->rs->post_id).'">'.
 		html::escapeHTML($this->rs->post_title).'</a></td>'.
-		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>'.
+		'<td class="nowrap count">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>'.
 		'<td class="nowrap">'.$cat_title.'</td>'.
 		'<td class="nowrap">'.html::escapeHTML($this->rs->user_id).'</td>'.
-		'<td class="nowrap">'.$this->rs->nb_comment.'</td>'.
-		'<td class="nowrap">'.$this->rs->nb_trackback.'</td>'.
+		'<td class="nowrap count">'.$this->rs->nb_comment.'</td>'.
+		'<td class="nowrap count">'.$this->rs->nb_trackback.'</td>'.
 		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'.
 		'</tr>';
@@ -234,5 +234,5 @@
 		'title="'.html::escapeHTML($this->rs->getURL()).'">'.
 		html::escapeHTML($this->rs->post_title).'</a></td>'.
-		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>'.
+		'<td class="nowrap count">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->post_dt).'</td>'.
 		'<td class="nowrap">'.html::escapeHTML($this->rs->user_id).'</td>'.
 		'<td class="nowrap status">'.$img_status.' '.$selected.' '.$protected.' '.$attach.'</td>'.
@@ -260,5 +260,6 @@
 			$html_block =
 			'<table><caption class="hidden">'.__('Comments and trackbacks list').'</caption><tr>'.
-			'<th colspan="3" scope="col" abbr="comm" class="first">'.__('Type and author').'</th>'.
+			'<th colspan="2" scope="col" abbr="comm" class="first">'.__('Type').'</th>'.
+			'<th scope="col">'.__('Author').'</th>'.
 			'<th scope="col">'.__('Date').'</th>'.
 			'<th scope="col" class="txt-center">'.__('Status').'</th>'.
@@ -326,4 +327,7 @@
 			$post_title = mb_strcut($post_title,0,57).'...';
 		}
+		$comment_title = sprintf(__('Edit the %1$s from %2$s'),
+			$this->rs->comment_trackback ? __('trackback') : __('comment'),
+			html::escapeHTML($this->rs->comment_author));
 		
 		$res = '<tr class="line'.($this->rs->comment_status != 1 ? ' offline' : '').'"'.
@@ -333,11 +337,10 @@
 		'<td class="nowrap">'.
 		form::checkbox(array('comments[]'),$this->rs->comment_id,'','','',0).'</td>'.
-		'<td class="status txt-center">'.
-			'<a href="'.$comment_url.'">'.
-			'<img src="images/edit-mini.png" alt="" title="'.__('Edit').'" /> '.
-			'</a>'.'</td>'.
-		'<td class="maximal" scope="row">'.($this->rs->comment_trackback ? __('trackback from') : __('comment from')).' '.
-			'<a href="'.$author_url.'">'.html::escapeHTML($this->rs->comment_author).'</a></td>'.
-		'<td class="nowrap">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->comment_dt).'</td>'.
+		'<td class="nowrap" abbr="'.__('Type and author').'" scope="raw">'.
+			'<a href="'.$comment_url.'" title="'.$comment_title.'">'.
+			'<img src="images/edit-mini.png" alt="'.__('Edit').'"/> '.
+			($this->rs->comment_trackback ? __('trackback') : __('comment')).' '.'</a></td>'.
+		'<td class="nowrap maximal"><a href="'.$author_url.'">'.html::escapeHTML($this->rs->comment_author).'</a></td>'.
+		'<td class="nowrap count">'.dt::dt2str(__('%Y-%m-%d %H:%M'),$this->rs->comment_dt).'</td>'.
 		'<td class="nowrap status txt-center">'.$img_status.'</td>'.
 		'<td class="nowrap"><a href="'.$post_url.'">'.
@@ -372,5 +375,5 @@
 			'<th scope="col">'.__('Last Name').'</th>'.
 			'<th scope="col">'.__('Display name').'</th>'.
-			'<th scope="col" class="nowrap">'.__('Entries').'</th>'.
+			'<th scope="col" class="nowrap">'.__('Entries (all types)').'</th>'.
 			'</tr>%s</table>';
 			
@@ -418,5 +421,5 @@
 		'<td class="nowrap">'.html::escapeHTML($this->rs->user_name).'</td>'.
 		'<td class="nowrap">'.html::escapeHTML($this->rs->user_displayname).'</td>'.
-		'<td class="nowrap"><a href="posts.php?user_id='.$this->rs->user_id.'">'.
+		'<td class="nowrap count"><a href="posts.php?user_id='.$this->rs->user_id.'">'.
 		$this->rs->nb_post.'</a></td>'.
 		'</tr>';
Index: inc/core/class.dc.trackback.php
===================================================================
--- inc/core/class.dc.trackback.php	(revision 1179)
+++ inc/core/class.dc.trackback.php	(revision 1674)
@@ -80,36 +80,56 @@
 		}
 		
-		$data = array(
-			'title' => $post_title,
-			'excerpt' => $post_excerpt,
-			'url' => $post_url,
-			'blog_name' => trim(html::escapeHTML(html::clean($this->core->blog->name)))
-			//,'__debug' => false
-		);
-		
-		# Ping
-		try
-		{
-			$http = self::initHttp($url,$path);
-			$http->post($path,$data,'UTF-8');
-			$res = $http->getContent();
-		}
-		catch (Exception $e)
-		{
-			throw new Exception(__('Unable to ping URL'));
-		}
-		
-		$pattern =
-		'|<response>.*<error>(.*)</error>(.*)'.
-		'(<message>(.*)</message>(.*))?'.
-		'</response>|msU';
-		
-		if (!preg_match($pattern,$res,$match))
-		{
-			throw new Exception(sprintf(__('%s is not a ping URL'),$url));
-		}
-		
-		$ping_error = trim($match[1]);
-		$ping_msg = (!empty($match[4])) ? $match[4] : '';
+		$ping_parts = explode('|',$url);
+		
+		# Let's walk by the trackback way
+		if (count($ping_parts) < 2) {
+			$data = array(
+				'title' => $post_title,
+				'excerpt' => $post_excerpt,
+				'url' => $post_url,
+				'blog_name' => trim(html::escapeHTML(html::clean($this->core->blog->name)))
+				//,'__debug' => false
+			);
+			
+			# Ping
+			try
+			{
+				$http = self::initHttp($url,$path);
+				$http->post($path,$data,'UTF-8');
+				$res = $http->getContent();
+			}
+			catch (Exception $e)
+			{
+				throw new Exception(__('Unable to ping URL'));
+			}
+			
+			$pattern =
+			'|<response>.*<error>(.*)</error>(.*)'.
+			'(<message>(.*)</message>(.*))?'.
+			'</response>|msU';
+			
+			if (!preg_match($pattern,$res,$match))
+			{
+				throw new Exception(sprintf(__('%s is not a ping URL'),$url));
+			}
+			
+			$ping_error = trim($match[1]);
+			$ping_msg = (!empty($match[4])) ? $match[4] : '';
+		}
+		# Damnit ! Let's play pingback
+		else {
+			try {
+				$xmlrpc = new xmlrpcClient($ping_parts[0]);
+				$res = $xmlrpc->query('pingback.ping', $post_url, $ping_parts[1]);
+				$ping_error = '0';
+			}
+			catch (xmlrpcException $e) {
+				$ping_error = $e->getCode();
+				$ping_msg = $e->getMessage();	
+			}
+			catch (Exception $e) {
+				throw new Exception(__('Unable to ping URL'));
+			}
+		}
 		
 		if ($ping_error != '0') {
@@ -289,4 +309,147 @@
 	}
 	//@}
+
+	/// @name Receive pingbacks
+	//@{
+	/**
+	Receives a pingback and insert it as a comment of given post.
+	
+	@param	from_url		<b>string</b>		Source URL
+	@param	to_url			<b>string</b>		Target URL
+	*/
+	public function receive_pb($from_url, $to_url)
+	{
+		$reg = '!^'.preg_quote($this->core->blog->url).'(.*)!';
+		$type = $args = $next = '';
+		
+		# Are you dumb?
+		if (!preg_match($reg, $to_url, $m)) {
+			throw new Exception(__('Any chance you ping one of my contents? No? Really?'), 0);
+		}
+		
+		# Does the targeted URL look like a registered post type? 
+		$url_part = $m[1];
+		$p_type = '';
+		$post_types = $this->core->getPostTypes();
+		foreach ($post_types as $k => $v) {
+			$reg = '!^'.preg_quote(str_replace('%s', '', $v['public_url'])).'(.*)!';
+			if (preg_match($reg, $url_part, $n)) {
+				$p_type = $k;
+				$post_url = $n[1];
+				break;
+			}
+		}
+		
+		if (empty($p_type)) {
+			throw new Exception(__('Sorry but you can not ping this type of content.'), 33);
+		}
+
+		# Time to see if we've got a winner...
+		$params = array(
+			'post_type' => $p_type,
+			'post_url' => $post_url,
+		);
+		$posts = $this->core->blog->getPosts($params);
+		
+		# Missed! 
+		if ($posts->isEmpty()) {
+			throw new Exception(__('Oops. Kinda "not found" stuff. Please check the target URL twice.'), 33);
+		}
+		
+		# Nice try. But, sorry, no.
+		if (!$posts->trackbacksActive()) {
+			throw new Exception(__('Sorry, dude. This entry does not accept pingback at the moment.'), 33);
+		}
+
+		# OK. We've found our champion. Time to check the remote part.
+		try {
+			$http = self::initHttp($from_url, $from_path);
+			
+			# First round : just to be sure the ping comes from an acceptable resource type.
+			$http->setHeadersOnly(true);
+			$http->get($from_path);
+			$c_type = explode(';', $http->getHeader('content-type'));
+
+			# Bad luck. Bye, bye...
+			if (!in_array($c_type[0],array('text/html', 'application/xhtml+xml'))) {
+				throw new Exception(__('Your source URL does not look like a supported content type. Sorry. Bye, bye!'), 0);
+			}
+			
+			# Second round : let's go fetch and parse the remote content
+			$http->setHeadersOnly(false);
+			$http->get($from_path);
+			$remote_content = $http->getContent();
+
+			$charset = mb_detect_encoding($remote_content,
+				'UTF-8,ISO-8859-1,ISO-8859-2,ISO-8859-3,'.
+				'ISO-8859-4,ISO-8859-5,ISO-8859-6,ISO-8859-7,ISO-8859-8,'.
+				'ISO-8859-9,ISO-8859-10,ISO-8859-13,ISO-8859-14,ISO-8859-15');
+
+			if (strtolower($charset) != 'utf-8') {
+				$remote_content = iconv($charset,'UTF-8',$remote_content);
+			}
+			
+			# We want a title...
+			if (!preg_match('!<title>([^<].*?)</title>!mis', $remote_content, $m)) {
+				throw new Exception(__('Where\'s your title?'), 0);
+			}
+			$title = trim(html::clean($m[1]));
+			$title = html::decodeEntities($title);
+			$title = html::escapeHTML($title);
+			$title = text::cutString($title,60);
+			
+			preg_match('!<body[^>]*?>(.*)?</body>!msi', $remote_content, $m);
+			$source = $m[1];
+			$source = preg_replace('![\r\n\s]+!ms',' ',$source);
+			$source = preg_replace( "/<\/*(h\d|p|th|td|li|dt|dd|pre|caption|input|textarea|button)[^>]*>/", "\n\n", $source );
+			$source = strip_tags($source, '<a>');
+			$source = explode("\n\n",$source);
+			
+			$excerpt = '';
+			foreach ($source as $line) {
+				if (strpos($line, $to_url) !== false) {
+					if (preg_match("!<a[^>]+?".$to_url."[^>]*>([^>]+?)</a>!", $line, $m)) {
+						$excerpt = strip_tags($line);
+						break;
+					}
+				}
+			}
+			if ($excerpt) {
+				$excerpt = '(&#8230;) '.text::cutString(html::escapeHTML($excerpt),255).' (&#8230;)';
+			}
+			else {
+				$excerpt = '(??)';
+			}
+
+			$comment =
+			"<!-- TB -->\n".
+			'<p><strong>'.$title."</strong></p>\n".
+			'<p>'.$excerpt.'</p>';
+			
+			$cur = $this->core->con->openCursor($this->core->prefix.'comment');
+			$cur->comment_author = 'Anonymous blog';
+			$cur->comment_site = (string) $from_url;
+			$cur->comment_content = (string) $comment;
+			$cur->post_id = $posts->post_id;
+			$cur->comment_trackback = 1;
+			$cur->comment_status = $this->core->blog->settings->system->trackbacks_pub ? 1 : -1;
+			$cur->comment_ip = http::realIP();
+			
+			# --BEHAVIOR-- publicBeforeTrackbackCreate
+			$this->core->callBehavior('publicBeforeTrackbackCreate',$cur);
+			if ($cur->post_id) {
+				$comment_id = $this->core->blog->addComment($cur);
+				
+				# --BEHAVIOR-- publicAfterTrackbackCreate
+				$this->core->callBehavior('publicAfterTrackbackCreate',$cur,$comment_id);
+			}
+		}
+		catch (Exception $e) {
+			throw new Exception(__('Sorry, an internal problem has occured.'), 0);
+		}
+		
+		return __('Thanks, mate. It was a pleasure.');
+	}
+	//@}
 	
 	private static function initHttp($url,&$path)
@@ -346,5 +509,5 @@
 			for ($i = 0; $i<count($match); $i++)
 			{
-				if (preg_match('/href="(http:\/\/[^"]+)"/ms', $match[$i][1], $matches)) {
+				if (preg_match('/href="((https?:\/)?\/[^"]+)"/ms', $match[$i][1], $matches)) {
 					$res[$matches[1]] = 1;
 				}
@@ -358,5 +521,5 @@
 			for ($i = 0; $i<count($match); $i++)
 			{
-				if (preg_match('/cite="(http:\/\/[^"]+)"/ms', $match[$i][2], $matches)) {
+				if (preg_match('/cite="((https?:\/)?\/[^"]+)"/ms', $match[$i][2], $matches)) {
 					$res[$matches[1]] = 1;
 				}
@@ -369,4 +532,8 @@
 	private function getPingURL($url)
 	{
+		if (strpos($url,'/') === 0) {
+			$url = http::getHost().$url;
+		}
+		
 		try
 		{
@@ -374,4 +541,5 @@
 			$http->get($path);
 			$page_content = $http->getContent();
+			$pb_url = $http->getHeader('x-pingback');
 		}
 		catch (Exception $e)
@@ -380,4 +548,20 @@
 		}
 		
+		# If we've got a X-Pingback header and it's a valid URL, it will be enough
+		if ($pb_url && filter_var($pb_url,FILTER_VALIDATE_URL) && preg_match('!^https?:!',$pb_url)) {
+			return $pb_url.'|'.$url;
+		}
+		
+		# No X-Pingback header. A link rel=pingback, maybe ?
+		$pattern_pingback = '!<link rel="pingback" href="(.*?)"( /)?>!msi';
+		
+		if (preg_match($pattern_pingback,$page_content,$m)) {
+			$pb_url = $m[1];
+			if (filter_var($pb_url,FILTER_VALIDATE_URL) && preg_match('!^https?:!',$pb_url)) {
+				return $pb_url.'|'.$url;
+			}
+		}
+
+		# No pingback ? OK, let's check for a trackback data chunk...
 		$pattern_rdf =
 		'/<rdf:RDF.*?>.*?'.
@@ -388,9 +572,12 @@
 		preg_match_all($pattern_rdf,$page_content,$rdf_all,PREG_SET_ORDER);
 		
+		$url_path = parse_url($url, PHP_URL_PATH);
+		$sanitized_url = str_replace($url_path, html::sanitizeURL($url_path), $url);
+		
 		for ($i=0; $i<count($rdf_all); $i++)
 		{
 			$rdf = $rdf_all[$i][1];
-			
-			if (preg_match('/dc:identifier="'.preg_quote($url,'/').'"/msi',$rdf)) {
+			if (preg_match('/dc:identifier="'.preg_quote($url,'/').'"/msi',$rdf) ||
+				preg_match('/dc:identifier="'.preg_quote($sanitized_url,'/').'"/msi',$rdf)) {
 				if (preg_match('/trackback:ping="(.*?)"/msi',$rdf,$tb_link)) {
 					return $tb_link[1];
Index: inc/core/class.dc.xmlrpc.php
===================================================================
--- inc/core/class.dc.xmlrpc.php	(revision 1179)
+++ inc/core/class.dc.xmlrpc.php	(revision 1674)
@@ -214,4 +214,9 @@
 			array('array','integer','string','string'),
 			'Retrieve all of the comment statuses.');
+			
+		# Pingback support
+		$this->addCallback('pingback.ping',array($this,'pingback_ping'),
+			array('string', 'string', 'string'),
+			'Notify a link to a post.');
 	}
 	
@@ -270,5 +275,5 @@
 	}
 	
-	private function setBlog()
+	private function setBlog($bypass = false)
 	{
 		if (!$this->blog_id) {
@@ -288,6 +293,7 @@
 		}
 		
-		if (!$this->core->blog->settings->system->enable_xmlrpc ||
-		!$this->core->auth->check('usage,contentadmin',$this->core->blog->id)) {
+		if (!$bypass &&
+			(!$this->core->blog->settings->system->enable_xmlrpc ||
+			!$this->core->auth->check('usage,contentadmin',$this->core->blog->id))) {
 			$this->core->blog = null;
 			throw new Exception('Not enough permissions on this blog.');
@@ -1629,4 +1635,18 @@
 		);
 	}
+
+	/* Pingback support
+	--------------------------------------------------- */
+	public function pingback_ping($from_url, $to_url)
+	{
+		# Come on, buddy! Don't make me waste time with this kind of silliness...
+		if (!(filter_var($from_url, FILTER_VALIDATE_URL) && preg_match('!^https?://!',$from_url))) {
+			throw new Exception(__('No valid source URL provided? Try again!'), 0);
+		}
+		
+		$this->setBlog(true);
+		$tb = new dcTrackback($this->core);
+		return $tb->receive_pb($from_url, $to_url);
+	}
 }
 ?>
Index: inc/public/class.dc.template.php
===================================================================
--- inc/public/class.dc.template.php	(revision 1611)
+++ inc/public/class.dc.template.php	(revision 1674)
@@ -70,4 +70,5 @@
 		$this->addValue('BlogID',array($this,'BlogID'));
 		$this->addValue('BlogURL',array($this,'BlogURL'));
+		$this->addValue('BlogXMLRPCURL',array($this,'BlogXMLRPCURL'));
 		$this->addValue('BlogPublicURL',array($this,'BlogPublicURL'));
 		$this->addValue('BlogQmarkURL',array($this,'BlogQmarkURL'));
@@ -906,4 +907,13 @@
 	
 	/*dtd
+	<!ELEMENT tpl:BlogXMLRPCURL - O -- Blog XML-RPC URL -->
+	*/
+	public function BlogXMLRPCURL($attr)
+	{
+		$f = $this->getFilters($attr);
+		return '<?php echo '.sprintf($f,'$core->blog->url.$core->url->getURLFor(\'xmlrpc\',$core->blog->id)').'; ?>';
+	}
+	
+	/*dtd
 	<!ELEMENT tpl:BlogURL - O -- Blog URL -->
 	*/
Index: inc/public/lib.urlhandlers.php
===================================================================
--- inc/public/lib.urlhandlers.php	(revision 1610)
+++ inc/public/lib.urlhandlers.php	(revision 1674)
@@ -480,4 +480,7 @@
 				
 				# The entry
+				if ($_ctx->posts->trackbacksActive()) {
+					header('X-Pingback: '.$core->blog->url.$core->url->getURLFor("xmlrpc",$core->blog->id));
+				}
 				self::serveDocument('post.html');
 			}
Index: plugins/pages/_public.php
===================================================================
--- plugins/pages/_public.php	(revision 1179)
+++ plugins/pages/_public.php	(revision 1674)
@@ -181,4 +181,7 @@
 				
 				# The entry
+				if ($_ctx->posts->trackbacksActive()) {
+					header('X-Pingback: '.$core->blog->url.$core->url->getURLFor("xmlrpc",$core->blog->id));
+				}
 				$core->tpl->setPath($core->tpl->getPath(), dirname(__FILE__).'/default-templates');
 				self::serveDocument('page.html');
Index: plugins/pages/page.php
===================================================================
--- plugins/pages/page.php	(revision 1711)
+++ plugins/pages/page.php	(revision 1713)
@@ -403,5 +403,5 @@
 			'items' => array(
 				'post_status' => 
-					'<p><label for="post_status" class="ib">'.__('Page status:').'</label> '.
+					'<p><label for="post_status" class="ib">'.__('Page status').'</label> '.
 					form::combo('post_status',$status_combo,$post_status,'','',!$can_publish).
 					'</p>',
@@ -411,5 +411,5 @@
 					'</p>',
 				'post_lang' =>
-					'<p><label for="post_lang" class="ib">'.__('Page lang:').'</label>'.
+					'<p><label for="post_lang" class="ib">'.__('Page lang').'</label>'.
 					form::combo('post_lang',$lang_combo,$post_lang).
 					'</p>',
@@ -426,5 +426,5 @@
 			'items' => array(
 				'post_position' => 
-					'<p><label for="post_position" class="classic">'.__('Page position:').'</label> '.
+					'<p><label for="post_position" class="classic">'.__('Page position').'</label> '.
 					form::field('post_position',3,3,(string) $post_position).
 					'</p>')),
